package cofh.thermal.expansion.block.entity.machine;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import cofh.core.util.helpers.FluidHelper;
import cofh.lib.api.StorageGroup;
import cofh.lib.fluid.FluidStorageCoFH;
import cofh.lib.inventory.ItemStorageCoFH;
import cofh.thermal.core.config.ThermalCoreConfig;
import cofh.thermal.core.util.managers.machine.PressRecipeManager;
import cofh.thermal.expansion.init.TExpTileEntities;
import cofh.thermal.expansion.inventory.container.machine.MachinePressContainer;
import cofh.thermal.lib.block.entity.MachineBlockEntity;
import cofh.thermal.lib.util.recipes.IMachineInventory;
import cofh.thermal.lib.util.recipes.IThermalInventory;
import cofh.thermal.lib.util.references.ThermalTags;
import java.util.List;
import javax.annotation.Nullable;
import net.minecraft.core.BlockPos;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.inventory.AbstractContainerMenu;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.block.entity.BlockEntityType;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraftforge.fluids.FluidStack;

public class MachinePressTile extends MachineBlockEntity {
  protected ItemStorageCoFH inputSlot;
  
  protected ItemStorageCoFH dieSlot;
  
  protected ItemStorageCoFH outputSlot;
  
  protected FluidStorageCoFH outputTank;
  
  public MachinePressTile(BlockPos pos, BlockState state) {
    super((BlockEntityType)TExpTileEntities.MACHINE_PRESS_TILE.get(), pos, state);
    this.inputSlot = new ItemStorageCoFH(item -> (this.filter.valid(item) && PressRecipeManager.instance().validInput(item)));
    this.dieSlot = new ItemStorageCoFH(item -> (item.m_41720_() instanceof cofh.thermal.core.item.SlotSealItem || (this.filter.valid(item) && PressRecipeManager.instance().validDie(item))));
    this.outputSlot = new ItemStorageCoFH();
    this.outputTank = new FluidStorageCoFH(4000);
    this.inventory.addSlot(this.inputSlot, StorageGroup.INPUT);
    this.inventory.addSlot(this.dieSlot, StorageGroup.INPUT);
    this.inventory.addSlot(this.outputSlot, StorageGroup.OUTPUT);
    this.inventory.addSlot(this.chargeSlot, StorageGroup.INTERNAL);
    this.tankInv.addTank(this.outputTank, StorageGroup.OUTPUT);
    addAugmentSlots(ThermalCoreConfig.machineAugments);
    initHandlers();
  }
  
  protected int getBaseProcessTick() {
    return PressRecipeManager.instance().getBasePower();
  }
  
  protected boolean cacheRecipe() {
    this.curRecipe = PressRecipeManager.instance().getRecipe((IThermalInventory)this);
    if (this.curRecipe != null)
      this.itemInputCounts = this.curRecipe.getInputItemCounts((IMachineInventory)this); 
    return (this.curRecipe != null);
  }
  
  protected boolean cacheRenderFluid() {
    if (this.curRecipe == null)
      return false; 
    FluidStack prevFluid = this.renderFluid;
    List<FluidStack> recipeOutputFluids = this.curRecipe.getOutputFluids((IMachineInventory)this);
    this.renderFluid = recipeOutputFluids.isEmpty() ? FluidStack.EMPTY : new FluidStack(recipeOutputFluids.get(0), 1000);
    return !FluidHelper.fluidsEqual(this.renderFluid, prevFluid);
  }
  
  protected void resolveInputs() {
    this.inputSlot.modify(-((Integer)this.itemInputCounts.get(0)).intValue());
    if (this.itemInputCounts.size() > 1 && !this.dieSlot.getItemStack().m_204117_(ThermalTags.Items.MACHINE_DIES))
      this.dieSlot.modify(-((Integer)this.itemInputCounts.get(1)).intValue()); 
  }
  
  @Nullable
  public AbstractContainerMenu m_7208_(int i, Inventory inventory, Player player) {
    return (AbstractContainerMenu)new MachinePressContainer(i, this.f_58857_, this.f_58858_, inventory, player);
  }
}
